---
- hosts: monitoring
  become: yes
  tasks:

    - name: Create build directory
      file:
        path: /root/demo
        state: directory
        owner: root
        group: root
        mode: '0755'

    - name: Copy src/monitor dir
      copy:
        src: ../src/monitor/main/
        dest: /root/demo/
        owner: root
        group: root
        mode: '0755'

    - name: Install required packages
      apt:
        name: unzip,joe,net-tools,snapd,docker.io,prometheus,consul,jo,python3-pip,prometheus-blackbox-exporter
        state: present
        update_cache: yes

    - name: start service snapd
      systemd:
        name: snapd
        state: started
        enabled: yes

    - name: Install Grafana with snap
      community.general.snap:
        name: grafana

    - name: restart grafana
      command: snap restart grafana

    - name: Install Modules for Python
      pip:
        name: docker,python-consul

    - name: Run consul script
      shell: sh /root/demo/server.sh > /root/demo/server.json

    - name: Copy config Consul
      copy:
        src: /root/demo/server.json
        dest: /etc/consul.d/
        owner: consul
        group: consul
        mode: '0600'
        remote_src: yes

    - name: Start service Consul
      systemd:
        name: consul
        state: started
        enabled: yes

    - name: Copy service file Consulexporter
      copy:
        src: /root/demo/consulexporter.service
        dest: /etc/systemd/system/
        owner: root
        group: root
        mode: '0755'
        remote_src: yes

    - name: reload systemd
      command: systemctl daemon-reload
 
    - name: Stop service Consulexporter
      ansible.builtin.service:
        name: consulexporter
        state: stopped

    - name: Remove the old containers if exist
      docker_container:
        name: consul
        state: absent

    - name: start service consulexporter
      systemd:
        name: consulexporter
        state: started
        enabled: yes

    - name: Copy config Prometheus
      copy:
        src: /root/demo/prometheus.yml
        dest: /etc/prometheus/
        owner: prometheus
        group: prometheus
        mode: '0600'
        remote_src: yes

    - name: start service prometheus
      systemd:
        name: prometheus
        state: restarted
        enabled: yes

#    - name: Kill all dockers consul-exporter
#      shell: docker rm -f consul

#    - name: Run consul-exporter in docker
#      shell: docker run -d -p 9107:9107 --name consul prom/consul-exporter --consul.server=mon1.akimov.space:8500

    - name: create prometheus datasource
      community.grafana.grafana_datasource:
        name: "${DS_PROMETHEUS-SERVER}"
        url: http://localhost:3000
        ds_type: prometheus
        ds_url: http://localhost:9090

    - name: Import dashboard Node Exporter
      community.grafana.grafana_dashboard:
        grafana_url: http://localhost:3000
        grafana_user: "admin"
        grafana_password: "admin"
        state: present
        commit_message: Updated by ansible
        overwrite: yes
        dashboard_id: 1860
        dashboard_revision: 20

#    - name: Import dashboard Consul_Exporter
#      community.grafana.grafana_dashboard:
#        grafana_url: http://localhost:3000
#        grafana_user: "admin"
#        grafana_password: "admin"
#        state: present
#        commit_message: Updated by ansible
#        overwrite: yes
#        dashboard_id: 12049

#    - name: Import Grafana dashboard consul
#      community.grafana.grafana_dashboard:
#        grafana_url: http://localhost:3000
#        grafana_user: "admin"
#        grafana_password: "admin"
#       state: present
#        commit_message: Updated by ansible
#        overwrite: yes
#        dashboard_url: https://akimov.freecluster.eu/devops/dashboard_consul.json
#        validate_certs: false

    - name: Add or update Consul KV
      community.general.consul_kv:
        key: release
        value: "{{ committag }}"
